﻿' IDE-Voreinstellungen:
' Option Explicit On
' Option Strict On
' Option Infer On

Imports System.IO

Module Module1

   Private Const Ranking As String = _
      "AaÄäBbCcDdEeFfGgHhIiJjKkLlMmNnOoÖöPpQqRrSsßTtUuÜüVvWwXxYyZz., +-/*_"
   Private Const Text As String = "Um ein Haar hätte ich die Türe doch geöffnet..."

#If VBC_VER = 9.0 Then
   ' VB2008-Compiler-Version 9.0: Extension-Method WriteTo() kann wie eine Objekt-Methode
   ' aufgerufen werden (Unterstützung durch Intellisense!)
   Sub Main()
      'Datei kopieren
      Using ReadStream As New FileStream("Test.doc", FileMode.Open), _
            WriteStream As New FileStream("Test2.doc", FileMode.Create)
         ReadStream.WriteTo(WriteStream)
      End Using
      Console.WriteLine("Copying done.")
      Console.WriteLine("press enter to continue.")
      Console.ReadLine()

      'Buchstaben nach benutzerdefiniertem Ranking sortieren
      'compare-Methode als Lambda-Ausdruck
      Dim compare As Comparison(Of Char) = Function(c1, c2) Ranking.IndexOf(c1) - Ranking.IndexOf(c2)
      Dim Chars = New List(Of Char)(Text.ToCharArray)
      Chars.Sort(compare)
      Console.WriteLine(New String(Chars.ToArray))
      Console.WriteLine("press enter to finish.")
      Console.ReadLine()
   End Sub

#Else
   ' niedrigere Versionen des VB-Compilers: WriteTo() "gewöhnlich" aufrufen
   Sub Main()
      'Datei kopieren
      Using ReadStream As New FileStream("Test.doc", FileMode.Open), _
            WriteStream As New FileStream("Test2.doc", FileMode.Create)
         WriteTo(ReadStream, WriteStream)
      End Using
      Console.WriteLine("Copying done.")
      Console.WriteLine("press enter to continue.")
      Console.ReadLine()

      'Buchstaben nach benutzerdefiniertem Ranking sortieren
      Dim Chars as New List(Of Char)(Text.ToCharArray)
      Chars.Sort(AddressOf compare)
      Console.WriteLine(New String(Chars.ToArray))
      Console.WriteLine("press enter to finish.")
      Console.ReadLine()
   End Sub

   'reguläre compare-Methode
   Private Function compare(ByVal c1 As Char, ByVal c2 As Char) As Integer
      Return Ranking.IndexOf(c1) - Ranking.IndexOf(c2)
   End Function

#End If

End Module
