﻿
Imports System.Runtime.CompilerServices
Imports System.IO

Public Module StreamX
   'VB2008-Extension-Methods: Das <Extension()>-Attribut bewirkt, daß sie wie ObjektMethoden aufrufbar sind, incl. Unterstützung durch die Intellisense

#If VBC_VER = 9.0 Then

   <Extension()> _
   Public Sub WriteTo( _
         ByVal ReadStream As Stream, _
         ByVal WriteStream As Stream, _
         Optional ByVal BytesToRead As Long = -1, _
         Optional ByVal Bufsize As Short = Short.MaxValue)
      If BytesToRead < 0 Then BytesToRead = ReadStream.Length
      Dim Buf(Bufsize - 1) As Byte
      Do
         ' Typ-Inference: Der Compiler erkennt den Typ von Portion anhand des
         ' Rückgabetyps von ReadStream.Read()
         Dim Portion = ReadStream.Read(Buf, 0, CInt(Math.Min(BytesToRead, Bufsize)))
         BytesToRead -= Portion
         WriteStream.Write(Buf, 0, Portion)
      Loop Until BytesToRead = 0
   End Sub

#Else
   'Downgrade: das <Extension()> - Attribut wurde entfernt, und der Datentyp von
   ' Portion explizit angegeben

   Public Sub WriteTo( _
         ByVal ReadStream As Stream, _
         ByVal WriteStream As Stream, _
         Optional ByVal BytesToRead As Long = -1, _
         Optional ByVal Bufsize As Integer = Short.MaxValue)
      If BytesToRead < 0 Then BytesToRead = ReadStream.Length
      Dim Buf(Bufsize - 1) As Byte
      Do
         'Kopier-Schleife von ReadStream -> WriteStream
         Dim Portion As Integer = ReadStream.Read(Buf, 0, CInt(Math.Min(BytesToRead, Bufsize)))
         BytesToRead -= Portion
         WriteStream.Write(Buf, 0, Portion)
      Loop Until BytesToRead = 0
   End Sub

#End If

End Module